"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var namingService_1 = require("../../services/namingService");
var ApimResource = /** @class */ (function () {
    function ApimResource() {
    }
    ApimResource.getResourceName = function (config) {
        return namingService_1.AzureNamingService.getResourceName(config, config.provider.apim, "apim");
    };
    ApimResource.prototype.getTemplate = function () {
        return {
            "$schema": "https://schema.management.azure.com/schemas/2015-01-01/deploymentTemplate.json#",
            "contentVersion": "1.0.0.0",
            "parameters": {
                "apiManagementName": {
                    "defaultValue": "",
                    "type": "String"
                },
                "location": {
                    "defaultValue": "",
                    "type": "String"
                },
                "apimSkuName": {
                    "defaultValue": "Consumption",
                    "type": "String"
                },
                "apimCapacity": {
                    "defaultValue": 0,
                    "type": "int"
                },
                "apimPublisherEmail": {
                    "defaultValue": "contact@contoso.com",
                    "type": "String"
                },
                "apimPublisherName": {
                    "defaultValue": "Contoso",
                    "type": "String"
                }
            },
            "variables": {},
            "resources": [
                {
                    "type": "Microsoft.ApiManagement/service",
                    "apiVersion": "2018-06-01-preview",
                    "name": "[parameters('apiManagementName')]",
                    "location": "[parameters('location')]",
                    "sku": {
                        "name": "[parameters('apimSkuName')]",
                        "capacity": "[parameters('apimCapacity')]"
                    },
                    "properties": {
                        "publisherEmail": "[parameters('apimPublisherEmail')]",
                        "publisherName": "[parameters('apimPublisherName')]",
                        "notificationSenderEmail": "apimgmt-noreply@mail.windowsazure.com",
                        "hostnameConfigurations": [],
                        "virtualNetworkType": "None"
                    }
                }
            ]
        };
    };
    ApimResource.prototype.getParameters = function (config) {
        var apimConfig = __assign({ sku: {} }, config.provider.apim);
        return {
            apiManagementName: ApimResource.getResourceName(config),
            apimSkuName: apimConfig.sku.name,
            apimSkuCapacity: apimConfig.sku.capacity,
            apimPublisherEmail: apimConfig.publisherEmail,
            apimPublisherName: apimConfig.publisherName,
        };
    };
    return ApimResource;
}());
exports.ApimResource = ApimResource;
