"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var namingService_1 = require("../../services/namingService");
var HostingEnvironmentResource = /** @class */ (function () {
    function HostingEnvironmentResource() {
    }
    HostingEnvironmentResource.getResourceName = function (config) {
        return namingService_1.AzureNamingService.getResourceName(config, config.provider.hostingEnvironment, "ase");
    };
    HostingEnvironmentResource.prototype.getTemplate = function () {
        return {
            "$schema": "https://schema.management.azure.com/schemas/2015-01-01/deploymentTemplate.json#",
            "contentVersion": "1.0.0.0",
            "parameters": {
                "hostingEnvironmentName": {
                    "defaultValue": "",
                    "type": "String"
                },
                "virtualNetworkName": {
                    "defaultValue": "",
                    "type": "String"
                },
                "location": {
                    "defaultValue": "",
                    "type": "String"
                }
            },
            "variables": {},
            "resources": [
                {
                    "type": "Microsoft.Web/hostingEnvironments",
                    "apiVersion": "2016-09-01",
                    "name": "[parameters('hostingEnvironmentName')]",
                    "location": "[parameters('location')]",
                    "dependsOn": [
                        "[resourceId('Microsoft.Network/virtualNetworks', parameters('virtualNetworkName'))]"
                    ],
                    "kind": "ASEV2",
                    "zones": [],
                    "properties": {
                        "name": "[parameters('hostingEnvironmentName')]",
                        "location": "[parameters('location')]",
                        "vnetName": "[parameters('virtualNetworkName')]",
                        "vnetResourceGroupName": "[resourceGroup().name]",
                        "vnetSubnetName": "default",
                        "virtualNetwork": {
                            "id": "[resourceId('Microsoft.Network/virtualNetworks', parameters('virtualNetworkName'))]",
                            "subnet": "default"
                        },
                        "internalLoadBalancingMode": "None",
                        "multiSize": "Standard_D1_V2",
                        "multiRoleCount": 2,
                        "ipsslAddressCount": 2,
                        "networkAccessControlList": [],
                        "frontEndScaleFactor": 15,
                        "suspended": false
                    }
                }
            ]
        };
    };
    HostingEnvironmentResource.prototype.getParameters = function (config) {
        return {
            hostingEnvironmentName: HostingEnvironmentResource.getResourceName(config)
        };
    };
    return HostingEnvironmentResource;
}());
exports.HostingEnvironmentResource = HostingEnvironmentResource;
