"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var xml_1 = __importDefault(require("xml"));
var arm_apimanagement_1 = require("@azure/arm-apimanagement");
var functionAppService_1 = require("./functionAppService");
var baseService_1 = require("./baseService");
var guard_1 = require("../shared/guard");
var apim_1 = require("../armTemplates/resources/apim");
/**
 * APIM Service handles deployment and integration with Azure API Management
 */
var ApimService = /** @class */ (function (_super) {
    __extends(ApimService, _super);
    function ApimService(serverless, options) {
        var _this = _super.call(this, serverless, options) || this;
        _this.apimConfig = _this.config.provider.apim;
        if (!_this.apimConfig) {
            return _this;
        }
        if (!_this.apimConfig.name) {
            _this.apimConfig.name = apim_1.ApimResource.getResourceName(_this.config);
        }
        if (!_this.apimConfig.backend) {
            _this.apimConfig.backend = {};
        }
        _this.apimClient = new arm_apimanagement_1.ApiManagementClient(_this.credentials, _this.subscriptionId);
        _this.functionAppService = new functionAppService_1.FunctionAppService(serverless, options);
        return _this;
    }
    /**
     * Gets the configured APIM resource
     */
    ApimService.prototype.get = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.apimConfig && this.apimConfig.name)) {
                            return [2 /*return*/, null];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.apimClient.apiManagementService.get(this.resourceGroup, this.apimConfig.name)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_1 = _a.sent();
                        return [2 /*return*/, null];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ApimService.prototype.getApi = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.apimConfig && this.apimConfig.api && this.apimConfig.api.name)) {
                            return [2 /*return*/, null];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.apimClient.api.get(this.resourceGroup, this.apimConfig.name, this.apimConfig.api.name)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_2 = _a.sent();
                        return [2 /*return*/, null];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deploys the APIM top level api
     */
    ApimService.prototype.deployApi = function () {
        return __awaiter(this, void 0, void 0, function () {
            var functionApp, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.apimConfig && this.apimConfig.name)) {
                            return [2 /*return*/, null];
                        }
                        return [4 /*yield*/, this.functionAppService.get()];
                    case 1:
                        functionApp = _a.sent();
                        return [4 /*yield*/, this.ensureApi()];
                    case 2:
                        api = _a.sent();
                        return [4 /*yield*/, this.ensureFunctionAppKeys(functionApp)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.ensureBackend(functionApp)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, api];
                }
            });
        });
    };
    /**
     * Deploys all the functions of the serverless service to APIM
     */
    ApimService.prototype.deployFunctions = function (service, api) {
        return __awaiter(this, void 0, void 0, function () {
            var deployApiTasks;
            var _this = this;
            return __generator(this, function (_a) {
                guard_1.Guard.null(service);
                guard_1.Guard.null(api);
                if (!(this.apimConfig && this.apimConfig.name)) {
                    return [2 /*return*/, null];
                }
                this.log("-> Deploying API Operations");
                deployApiTasks = this.serverless.service
                    .getAllFunctions()
                    .map(function (functionName) { return _this.deployFunction(service, api, { function: functionName }); });
                return [2 /*return*/, Promise.all(deployApiTasks)];
            });
        });
    };
    /**
     * Deploys the specified serverless function  to APIM
     * @param options
     */
    ApimService.prototype.deployFunction = function (service, api, options) {
        return __awaiter(this, void 0, void 0, function () {
            var functionConfig, tasks;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(service);
                        guard_1.Guard.null(api);
                        guard_1.Guard.null(options);
                        functionConfig = this.serverless.service["functions"][options.function];
                        if (!(functionConfig && functionConfig.apim)) {
                            return [2 /*return*/];
                        }
                        tasks = functionConfig.apim.operations.map(function (operation) {
                            return _this.deployOperation(service, api, {
                                function: options.function,
                                operation: operation,
                            });
                        });
                        return [4 /*yield*/, Promise.all(tasks)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deploys the APIM API referenced by the serverless service
     */
    ApimService.prototype.ensureApi = function () {
        return __awaiter(this, void 0, void 0, function () {
            var api, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.log("-> Deploying API");
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        return [4 /*yield*/, this.apimClient.api.createOrUpdate(this.resourceGroup, this.apimConfig.name, this.apimConfig.api.name, {
                                isCurrent: true,
                                subscriptionRequired: this.apimConfig.api.subscriptionRequired,
                                displayName: this.apimConfig.api.displayName,
                                description: this.apimConfig.api.description,
                                path: this.apimConfig.api.path,
                                protocols: this.apimConfig.api.protocols,
                            })];
                    case 2:
                        api = _a.sent();
                        if (!this.apimConfig.cors) return [3 /*break*/, 4];
                        this.log("-> Deploying CORS policy");
                        return [4 /*yield*/, this.apimClient.apiPolicy.createOrUpdate(this.resourceGroup, this.apimConfig.name, this.apimConfig.api.name, {
                                format: "rawxml",
                                value: this.createCorsXmlPolicy(this.apimConfig.cors)
                            })];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/, api];
                    case 5:
                        e_1 = _a.sent();
                        this.log("Error creating APIM API");
                        this.log(JSON.stringify(e_1.body, null, 4));
                        throw e_1;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deploys the APIM Backend referenced by the serverless service
     * @param functionAppUrl The host name for the deployed function app
     */
    ApimService.prototype.ensureBackend = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var backendUrl, functionAppResourceId, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backendUrl = "https://" + functionApp.defaultHostName + "/api";
                        this.log("-> Deploying API Backend " + functionApp.name + " = " + backendUrl);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        functionAppResourceId = "https://management.azure.com" + functionApp.id;
                        return [4 /*yield*/, this.apimClient.backend.createOrUpdate(this.resourceGroup, this.apimConfig.name, this.serviceName, {
                                credentials: {
                                    header: {
                                        "x-functions-key": ["{{" + this.serviceName + "-key}}"],
                                    },
                                },
                                title: this.apimConfig.backend.title || functionApp.name,
                                tls: this.apimConfig.backend.tls,
                                proxy: this.apimConfig.backend.proxy,
                                description: this.apimConfig.backend.description,
                                protocol: this.apimConfig.backend.protocol || "http",
                                resourceId: functionAppResourceId,
                                url: backendUrl,
                            })];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        e_2 = _a.sent();
                        this.log("Error creating APIM Backend");
                        this.log(JSON.stringify(e_2.body, null, 4));
                        throw e_2;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deploys a single APIM api operation for the specified function
     * @param serverless The serverless framework
     * @param options The plugin options
     */
    ApimService.prototype.deployOperation = function (service, api, options) {
        return __awaiter(this, void 0, void 0, function () {
            var client, operationConfig, operationPath, operationUrl, operation, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        client = new arm_apimanagement_1.ApiManagementClient(this.credentials, this.subscriptionId);
                        operationConfig = {
                            displayName: options.operation.displayName || options.function,
                            description: options.operation.description || "",
                            method: options.operation.method,
                            urlTemplate: options.operation.urlTemplate,
                            templateParameters: options.operation.templateParameters || [],
                            responses: options.operation.responses || [],
                        };
                        operationPath = ("/" + api.path + "/" + operationConfig.urlTemplate).replace(/\/+/g, "/");
                        operationUrl = "" + service.gatewayUrl + operationPath;
                        this.log("--> Deploying API operation " + options.function + ": " + operationConfig.method.toUpperCase() + " " + operationUrl);
                        return [4 /*yield*/, client.apiOperation.createOrUpdate(this.resourceGroup, this.apimConfig.name, this.apimConfig.api.name, options.function, operationConfig)];
                    case 1:
                        operation = _a.sent();
                        return [4 /*yield*/, client.apiOperationPolicy.createOrUpdate(this.resourceGroup, this.apimConfig.name, this.apimConfig.api.name, options.function, {
                                format: "rawxml",
                                value: this.createApiOperationXmlPolicy(),
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, operation];
                    case 3:
                        e_3 = _a.sent();
                        this.log("Error deploying API operation " + options.function);
                        this.log(JSON.stringify(e_3.body, null, 4));
                        throw e_3;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Gets the master key for the function app and stores a reference in the APIM instance
     * @param functionAppUrl The host name for the Azure function app
     */
    ApimService.prototype.ensureFunctionAppKeys = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var masterKey, keyName, e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.log("-> Deploying API keys");
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.functionAppService.getMasterKey(functionApp)];
                    case 2:
                        masterKey = _a.sent();
                        keyName = this.serviceName + "-key";
                        return [4 /*yield*/, this.apimClient.property.createOrUpdate(this.resourceGroup, this.apimConfig.name, keyName, {
                                displayName: keyName,
                                secret: true,
                                value: masterKey,
                            })];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4:
                        e_4 = _a.sent();
                        this.log("Error creating APIM Property");
                        this.log(JSON.stringify(e_4.body, null, 4));
                        throw e_4;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Creates the XML payload that defines the API operation policy to link to the configured backend
     */
    ApimService.prototype.createApiOperationXmlPolicy = function () {
        var operationPolicy = [{
                policies: [
                    {
                        inbound: [
                            { base: null },
                            {
                                "set-backend-service": [
                                    {
                                        "_attr": {
                                            "id": "apim-generated-policy",
                                            "backend-id": this.serviceName,
                                        }
                                    },
                                ],
                            },
                        ],
                    },
                    { backend: [{ base: null }] },
                    { outbound: [{ base: null }] },
                    { "on-error": [{ base: null }] },
                ]
            }];
        return xml_1.default(operationPolicy);
    };
    /**
     * Creates the XML payload that defines the specified CORS policy
     * @param corsPolicy The CORS policy
     */
    ApimService.prototype.createCorsXmlPolicy = function (corsPolicy) {
        var origins = corsPolicy.allowedOrigins ? corsPolicy.allowedOrigins.map(function (origin) { return ({ origin: origin }); }) : null;
        var methods = corsPolicy.allowedMethods ? corsPolicy.allowedMethods.map(function (method) { return ({ method: method }); }) : null;
        var allowedHeaders = corsPolicy.allowedHeaders ? corsPolicy.allowedHeaders.map(function (header) { return ({ header: header }); }) : null;
        var exposeHeaders = corsPolicy.exposeHeaders ? corsPolicy.exposeHeaders.map(function (header) { return ({ header: header }); }) : null;
        var policy = [{
                policies: [
                    {
                        inbound: [
                            { base: null },
                            {
                                cors: [
                                    { "_attr": { "allow-credentials": corsPolicy.allowCredentials } },
                                    { "allowed-origins": origins },
                                    { "allowed-methods": methods },
                                    { "allowed-headers": allowedHeaders },
                                    { "expose-headers": exposeHeaders },
                                ]
                            }
                        ],
                    },
                    { backend: [{ base: null }] },
                    { outbound: [{ base: null }] },
                    { "on-error": [{ base: null }] },
                ]
            }];
        return xml_1.default(policy, { indent: "\t" });
    };
    return ApimService;
}(baseService_1.BaseService));
exports.ApimService = ApimService;
